/*
 * Definitions etc. for regexp(3) routines.
 *
 * Caveat:  this is V8 regexp(3) [actually, a reimplementation thereof],
 * not the System V one.
 */
#define NSUBEXP  10
typedef struct regexp {
    char *startp[NSUBEXP];
    char *endp[NSUBEXP];
    char regstart;                     /* Internal use only. */
    char reganch;                      /* Internal use only. */
    char *regmust;                     /* Internal use only. */
    int regmlen;                       /* Internal use only. */
    char program[1];                   /* Unwarranted chumminess with
                                          compiler. */
} regexp;

/* macro to protect ANSI C function prototypes */

#ifndef P__
#if defined(__STDC__) || defined(__GNUC__) || defined(__TURBOC__)
#define P__(s) s
#define ANSI_C
#else
#define P__(s) ()
#undef ANSI_C
#endif
#endif                                 /* P__ */

extern regexp *regcomp P__((const char *exp));
extern int regexec P__((const regexp * prog, const char *string));
extern void regsub P__((const regexp * prog, const char *src, char *dest));
extern void regerror P__((const char *s));
