/*
 * Sample Source KeySource file.
 *
 * Andy Duplain, Nov 1993.
 */

echo +------------------------------+
echo | Sample Source KeySource file |
echo +------------------------------+

info_tests_only		true
subkey_related		true

key "Zonal tournament" {
	source "[- ]zt"
}
key "Interzonals" {
	source "[- ]izt"
}
key "Olympiad" {
	source "[- ]olm?"
}
key "Open" {
	source "[- ]op"
}
key "Cup tournament" {
	source "[- ]cup"
}
key "Championships" {
	source "[- ]ch"
	key "World championship" {
		source "[- ]W[cC]h"
	}
	key "National championships" {
		source "[A-Z]+-[cC]h"
	}
	key "Team championships" {
		source "[- ]t-[cC]h"
	}
	key "German team championships (Bundesliga)" {
		source "[- ]BL"
	}
}
key "Correspondence" {
	source "corr"
}
key "Finals" {
	source "[- ]f"
}
key "Candidates tournaments" {
	source "[- ]ct"
}
key "Candidates matches" {
	source "[- ]cm"
}
key "Junior" {
	source "[- ]jr"
}
key "Youth" {
	source "( Y$| Y )"
}
key "Women" {
	source "[- ]wom"
}
key "Team tournament" {
	source "[- ]tt"
}
key "Semifinals" {
	source "[- ]sf"
}
key "Quaterfinals" {
	source "[- ]qf"
}
key "A..." {
	source "^[aA]"
}
key "B..." {
	source "^[bB]"
}
key "C..." {
	source "^[cC]"
}
key "D..." {
	source "^[dD]"
}
key "E..." {
	source "^[eE]"
}
key "F..." {
	source "^[fF]"
}
key "G..." {
	source "^[gG]"
}
key "H..." {
	source "^[hH]"
}
key "I..." {
	source "^[iI]"
}
key "J..." {
	source "^[jJ]"
}
key "K..." {
	source "^[kK]"
}
key "L..." {
	source "^[lL]"
}
key "M..." {
	source "^[mM]"
}
key "N..." {
	source "^[nN]"
}
key "O..." {
	source "^[oO]"
}
key "P..." {
	source "^[pP]"
}
key "Q..." {
	source "^[qQ]"
}
key "R..." {
	source "^[rR]"
}
key "S..." {
	source "^[sS]"
}
key "T..." {
	source "^[tT]"
}
key "U..." {
	source "^[uU]"
}
key "V..." {
	source "^[vV]"
}
key "W..." {
	source "^[wW]"
}
key "X..." {
	source "^[yY]"
}
key "Z..." {
	source "^[zZ]"
}
